package com.fp.persistence.pgeneral.date;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENENOTACCOUNTINGDAY*/
@Embeddable
public class TgeneNotAccountingDayKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CATALOG", nullable=false,updatable=false)

/**
* Codigo de catalogo  0 Enero, 1 Febreo, 2 Marzo 
*/
private String catalog;

@Column(name="DAY", nullable=false,updatable=false)

/**
* Dia del mes que no se considera como contable
*/
private Integer day;

/**Contructor por defecto*/
public TgeneNotAccountingDayKey(){}
/**Contructor de TgeneNotAccountingDayKey
@param pCatalog Codigo de catalogo  0 Enero, 1 Febreo, 2 Marzo 
@param pDay Dia del mes que no se considera como contable
*/
public TgeneNotAccountingDayKey(String pCatalog,Integer pDay){
 catalog=pCatalog;
 day=pDay;
}
/**Obtiene el valor de catalog
@return valor de catalog*/
public String getCatalog(){
  return catalog;
}
/**Fija el valor de catalog
@param pCatalog nuevo Valor de catalog*/
public void setCatalog(String pCatalog){
  catalog=pCatalog;
}

/**Obtiene el valor de day
@return valor de day*/
public Integer getDay(){
  return day;
}
/**Fija el valor de day
@param pDay nuevo Valor de day*/
public void setDay(Integer pDay){
  day=pDay;
}

/**Implementación de la comparación de TgeneNotAccountingDayKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneNotAccountingDayKey))return false;
  TgeneNotAccountingDayKey that = (TgeneNotAccountingDayKey) o;
  if (this.getCatalog() == null || that.getCatalog() == null){
      return false;
  }
  if (! this.getCatalog().equals(that.getCatalog())){
    return false;
  }
  if (this.getDay() == null || that.getDay() == null){
      return false;
  }
  if (! this.getDay().equals(that.getDay())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneNotAccountingDayKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCatalog() == null ? 0 : this.getCatalog().hashCode());
    result = result * 37 + (this.getDay() == null ? 0 : this.getDay().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
